/**
* @package MediaBox404_prg
* @copyright (C) 2004 - 2005 erreur404.org
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* MediaBox404 is Free Software
* @author vortex@erreur404.org
* $Id: mysql_utils.c,v 1.3 2005/07/18 18:46:54 bedlam Exp $
*/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include "scheduler404.h"
#include "xml_config.h"
#include "log.h"

void Reset_Last_Playlist(MYSQL *mysql, 
			 mediabox404_config_t *mediabox404_config)
{
    int t;
    char query[4096];
    
    sprintf(query, "delete from %s", mediabox404_config->sql.lastplaylist);

    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Reset_Last_Playlist:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
}

void Stop_Current_Stream(MYSQL *mysql, 
			 mediabox404_config_t *mediabox404_config)
{
    int t;
    char query[4096];
    
    sprintf(query, "insert into %s (S_UserID,S_Code,D_DateTime) values (0,'STOP',now())",
	    mediabox404_config->sql.pilotstack);

    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Stop_Current_Stream:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    mediabox404_log_debug("Stop_Current_Stream");
}

void Insert_Log(MYSQL *mysql,
		mediabox404_config_t *mediabox404_config,
		unsigned int UserID,
		char* Code,
		unsigned int DataID,
		char* Arg1,
		char* Arg2,
		char* Arg3,
		char* Arg4,
		char* Arg5,
		char* Arg6,
		char* Arg7,
		char* Filename)
{
    int t;
    char query[5000];
    char Arg1_mysql[2048];
    char Arg2_mysql[1024];
    char Arg3_mysql[1024];
    char Arg4_mysql[1024];
    char Arg5_mysql[1024];
    char Arg6_mysql[1024];
    char Arg7_mysql[1024];
    char Filename_mysql[1024];

    mysql_real_escape_string(mysql, Filename_mysql, 
			     Filename, strlen(Filename));
    mysql_real_escape_string(mysql, Arg1_mysql, Arg1, strlen(Arg1));
    mysql_real_escape_string(mysql, Arg2_mysql, Arg2, strlen(Arg2));
    mysql_real_escape_string(mysql, Arg3_mysql, Arg3, strlen(Arg3));
    mysql_real_escape_string(mysql, Arg4_mysql, Arg4, strlen(Arg4));
    mysql_real_escape_string(mysql, Arg5_mysql, Arg5, strlen(Arg5));
    mysql_real_escape_string(mysql, Arg6_mysql, Arg6, strlen(Arg6));
    mysql_real_escape_string(mysql, Arg7_mysql, Arg7, strlen(Arg7));
    
    sprintf(query,"insert into %s (S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7,S_Filename) values (%d,'%s',now(),%d,'%s','%s','%s','%s','%s','%s','%s','%s')",
	    mediabox404_config->sql.log, UserID, Code, DataID,
	    Arg1_mysql, Arg2_mysql, Arg3_mysql, Arg4_mysql, Arg5_mysql,
	    Arg6_mysql, Arg7_mysql, Filename_mysql);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Path:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
}

void Insert_streamstack_live(MYSQL *mysql,
			     mediabox404_config_t *mediabox404_config,
			     unsigned int UserID,
			     unsigned int ProgID,
			     char* URL,
			     char* LIVE_Format,
			     unsigned int LIVE_Bitrate,
			     unsigned int LIVE_Frequence,
			     unsigned int LIVE_NbCanal,
			     unsigned int LIVE_NbReconnect,
			     unsigned int PlayTime)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t, BeginID;
    char query[4096];
    char url_mysql[2048];
    char StrProgID[10];
    
    sprintf(query, "select S_ID from %s order by S_ID ASC LIMIT 1",
	    mediabox404_config->sql.streamstack);
    
    BeginID = 1;
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_error("Insert_streamstack_live1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }

    res = mysql_store_result(mysql);
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	BeginID = atoi(row[0]);
    }
    mysql_free_result(res);
    
    sprintf(StrProgID,"%d",ProgID);
    
    mysql_real_escape_string(mysql, url_mysql,URL,strlen(URL));  
    
    sprintf(query,"insert into %s (S_ID,S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7) values (%d,%d,'LIVE',now(),%d,'%s','%s','%d','%d','%d','%d','%d')",
	    mediabox404_config->sql.streamstack, BeginID-1, UserID, ProgID,
	    url_mysql, LIVE_Format, LIVE_Bitrate, LIVE_Frequence,
	    LIVE_NbCanal, LIVE_NbReconnect, PlayTime);

    Insert_Log(mysql, mediabox404_config, 0, "LIVE", UserID, LIVE_Format,
	       "", "", "", "", "", StrProgID, URL);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_streamstack_live2:Error making query: %s",
			      mysql_error(mysql));
    }
}

void Insert_streamstack_relay(MYSQL *mysql,
			      mediabox404_config_t *mediabox404_config,
			      unsigned int UserID,
			      unsigned int ProgID,
			      char* URL,
			      char* LIVE_Format,
			      unsigned int LIVE_Bitrate,
			      unsigned int LIVE_Frequence,
			      unsigned int LIVE_NbCanal,
			      unsigned int LIVE_NbReconnect,
			      unsigned int PlayTime)
{
    int t;
    char query[4096];
    char url_mysql[2048];
    char StrProgID[10];

    sprintf(StrProgID, "%d", ProgID);
    
    mysql_real_escape_string(mysql, url_mysql, URL, strlen(URL));  
    
    sprintf(query,"insert into %s (S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7) values (%d,'LIVE',now(),%d,'%s','%s','%d','%d','%d','%d','%d')",
	    mediabox404_config->sql.streamstack, UserID, ProgID, url_mysql,
	    LIVE_Format, LIVE_Bitrate, LIVE_Frequence, LIVE_NbCanal,
	    LIVE_NbReconnect, PlayTime);
    Insert_Log(mysql, mediabox404_config, 0, "RELAY", UserID, LIVE_Format,
	       "", "", "", "", "", StrProgID, URL);
	
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_streamstack_relay2:Error making query: %s",
			      mysql_error(mysql));
    }
}

void Copy_streamstack_tempstack(MYSQL *mysql, 
				mediabox404_config_t *mediabox404_config)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t, t2;
    char query[4096], query2[4096];
    unsigned long *lengths;
    
    
    sprintf(query,"delete from t_tempstack");
  
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
   
    if (t){
	mediabox404_log_debug("Copy_streamstack_tempstack1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    
    sprintf(query, "select * from %s", mediabox404_config->sql.streamstack);
    t = mysql_real_query(mysql, query, (unsigned int) strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_streamstack_tempstack2:Select Error making query: %s",
			      mysql_error(mysql));
	return;
    }

    res = mysql_store_result(mysql);
    
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    lengths = mysql_fetch_lengths(res);
	    sprintf(query2,"insert into %s values (%s,%s,'%s','%s',%s,'%s','%s','%s','%s','%s','%s','%s','%s',%s)",
		    mediabox404_config->sql.tempstack, row[0], row[1], row[2],
		    row[3], row[4], row[5], row[6], row[7], row[8], row[9],
		    row[10], row[11], row[12], row[13]);
	    t2 = mysql_real_query(mysql, query2, (unsigned int)strlen(query2));
	    if (t2) {
		mediabox404_log_debug("Copy_streamstack_tempstack2:Error making query: %s",
				      mysql_error(mysql));
		return;
	    }
	}
    }
	
    sprintf(query, "delete from %s", mediabox404_config->sql.streamstack);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_streamstack_tempstack1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
}

void Copy_tempstack_streamstack(MYSQL *mysql, 
				mediabox404_config_t *mediabox404_config)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t,t2;
    char query[4096];
    char query2[4096];
    unsigned long *lengths;
    
    
    sprintf(query, "select * from %s", mediabox404_config->sql.tempstack);
	
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_streamstack_tempstack2:Select Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
	
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    lengths = mysql_fetch_lengths(res);
	    sprintf(query2,"insert into %s values (%s,%s,'%s','%s',%s,'%s','%s','%s','%s','%s','%s','%s','%s',%s)",
		    mediabox404_config->sql.streamstack, row[0], row[1], 
		    row[2], row[3], row[4], row[5], row[6], row[7], row[8],
		    row[9], row[10], row[11], row[12], row[13]);
	    t2 = mysql_real_query(mysql, query2, (unsigned int)strlen(query2));
	    if (t2) {
		mediabox404_log_debug("Copy_streamstack_tempstack2:Error making query: %s",
				      mysql_error(mysql));
		return;
	    }
	}
    }
    
    sprintf(query, "delete from %s", mediabox404_config->sql.tempstack);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_tempstack_streamstack2:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
}

void Insert_streamstack_data(MYSQL *mysql,
			     mediabox404_config_t *mediabox404_config,
			     unsigned int PlaylistID,
			     unsigned int DataID,
			     unsigned int TrackID,
			     char* TrackType,
			     int *nb_control_play)
{
    MYSQL_RES *res;
    MYSQL_RES *res2;
    MYSQL_ROW row;
    int t,Playtime;
    int control_prog = 0; 
    char date_prg_control[32];
    char query[2048];
    char DataPath[4096];
    char FileName[4096];
    char Path[4096];
    char FileType[10];
    char Genre[128];
    char Artist[128];
    char Album[128];
    char Title[128];
    char Genre_mysql[128];
    char Artist_mysql[128];
    char Album_mysql[128];
    char Title_mysql[128];
    char datapath_mysql[4096];
    int PathRoot = 0;
    char Str_PlaylistID[10];
    time_t now_datetime = 0;
    struct tm *datetime;
    int nb_data;
    unsigned long *lengths;
    
    // je n'insert pas le mme data dans la pile
    sprintf(query, "select * from %s where S_DataID = %d",
	    mediabox404_config->sql.streamstack,DataID);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_streamstack_data:Error select S_DataID: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    nb_data = mysql_num_rows(res);
    mysql_free_result(res);
    
    if (nb_data == 0){
	
	sprintf(Str_PlaylistID, "%d", PlaylistID);
	sprintf(query, "select datapath.S_PathRootID,datapath.S_Path,data.S_Filename,data.S_FileType,data.S_Genre,data.S_Artist,data.S_Album,data.S_Title,data.S_Playtime  from %s data,%s datapath where data.S_ID = %d and data.S_PathID = datapath.S_ID",
		mediabox404_config->sql.data,
		mediabox404_config->sql.datapath, DataID);
	
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_streamstack_data1:Error making query: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    lengths = mysql_fetch_lengths(res);
	    PathRoot = atoi(row[0]);
	    sprintf(Path,"%.*s", (int) lengths[1], row[1] ? row[1] : "NULL");
	    sprintf(FileName,"%.*s", (int) lengths[2], 
		    row[2] ? row[2] : "NULL");
	    sprintf(FileType,"%.*s", (int) lengths[3], 
		    row[3] ? row[3] : "NULL");
	    sprintf(Genre,"%.*s", (int) lengths[4], row[4] ? row[4] : "NULL");
	    sprintf(Artist,"%.*s", (int) lengths[5], row[5] ? row[5] : "NULL");
	    sprintf(Album,"%.*s", (int) lengths[6], row[6] ? row[6] : "NULL");
	    sprintf(Title,"%.*s", (int) lengths[7], row[7] ? row[7] : "NULL");
	    Playtime = atoi(row[8]);
	    
	    mediabox404_log_debug("Add ? %s",FileName);
	    mysql_real_escape_string(mysql, Genre_mysql, Genre, strlen(Genre));
	    mysql_real_escape_string(mysql, Artist_mysql, Artist, 
				     strlen(Artist));  
	    mysql_real_escape_string(mysql, Album_mysql,Album,strlen(Album));  
	    mysql_real_escape_string(mysql, Title_mysql,Title,strlen(Title));  
	    
	    // contrle de la programmation
	    // pas de d'artiste identique
	    if ((strcmp(TrackType, "MAIN") == 0) &&
		(*nb_control_play < (mediabox404_config->max_control - 1))) {
		
		time(&now_datetime);
		now_datetime = now_datetime - 
		    mediabox404_config->period_control*60*60;
		
		datetime = localtime(&now_datetime);
		sprintf(date_prg_control, "%04d-%02d-%02d %02d:%02d:%02d",
			1900+datetime->tm_year, datetime->tm_mon + 1, 
			datetime->tm_mday, datetime->tm_hour, datetime->tm_min,
			datetime->tm_sec);
		
		if (strlen(Artist) > 0) {
		    // contrle de l'artiste
		    sprintf(query, "select * from %s streamlog,%s data where streamlog.D_DateTime >= '%s' and streamlog.S_DataID = data.S_ID and data.s_artist = '%s'",
			    mediabox404_config->sql.streamlog,
			    mediabox404_config->sql.data,
			    date_prg_control, Artist_mysql); //mediabox404_config->
		    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
		    if (t) {
			mediabox404_log_debug("Insert_streamstack_data_ctrl4:Error making query: %s",
					      mysql_error(mysql));
			return;
		    }
		    res2 = mysql_store_result(mysql);
		    control_prog = mysql_num_rows(res2);
		    mysql_free_result(res2);
		} else {
		    // contrle du morceau
		    sprintf(query, "select * from %s where D_DateTime >= '%s' and S_DataID = %d",
			    mediabox404_config->sql.streamlog,
			    date_prg_control, DataID);

		    t = mysql_real_query(mysql, query, 
					 (unsigned int)strlen(query));
		    if (t) {
			mediabox404_log_debug("Insert_streamstack_data_ctrl4:Error making query: %s",
					      mysql_error(mysql));
			return;
		    }
		    res2 = mysql_store_result(mysql);
		    control_prog = mysql_num_rows(res2);
		    mysql_free_result(res2);
		}
	    }
	    if (control_prog == 0) {
		mediabox404_log_debug("Add %s", FileName);
		*nb_control_play = 0;
		if (PathRoot > 0) { 
		    // Local
		    sprintf(DataPath, "%s/%s", Path, FileName);
		    mysql_real_escape_string(mysql, datapath_mysql, DataPath,
					     strlen(DataPath));  
		    sprintf(query, "insert into %s (S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7,S_Argument8,S_TrackID) values (0,'PLAY',now(),%d,'%s','%s','LOCAL','%s','%s','%s - %s',%d,%d,%d)", mediabox404_config->sql.streamstack,
			    DataID, datapath_mysql, FileType, TrackType,
			    Artist_mysql, Album_mysql, Title_mysql,
			    Playtime, PlaylistID, TrackID);
		} else {
		    mysql_real_escape_string(mysql, datapath_mysql, FileName, 
					     strlen(FileName));  
		    sprintf(query, "insert into %s (S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7,S_Argument8,S_TrackID) values (0,'PLAY',now(),%d,'%s','%s','REMOTE','%s','%s','%s - %s',%d,%d,%d)",
			    mediabox404_config->sql.streamstack, DataID,
			    datapath_mysql, FileType, TrackType, Artist_mysql,
			    Album_mysql, Title_mysql, Playtime, PlaylistID,
			    TrackID);
			}
			
		
		t = mysql_real_query(mysql, query, 
				     (unsigned int)strlen(query));
		if (t) {
		    mediabox404_log_debug("Insert_streamstack_data2:Error making query: %s",
					  mysql_error(mysql));
		}
	    } else {
		// logger le morceau non diffus
		(*nb_control_play)++;
		sprintf(DataPath, "%s/%s", Path, FileName);
		mysql_real_escape_string(mysql, datapath_mysql, DataPath,
					 strlen(DataPath));  
		Insert_Log(mysql, mediabox404_config, 0, "No Diff", DataID,
			   Genre_mysql, Artist_mysql, Album_mysql, Title_mysql,
			   "LOCAL", FileType, Str_PlaylistID, datapath_mysql);
	    }
	    
	}
	mysql_free_result(res);
    }
}

void Insert_streamstack_data_begin(MYSQL *mysql,
				   mediabox404_config_t *mediabox404_config,
				   unsigned int PlaylistID,
				   unsigned int DataID,
				   unsigned int TrackID,
				   char* TrackType)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t,Playtime;
    char query[2048];
    char DataPath[4096];
    char FileName[4096];
    char Path[4096];
    char FileType[10];
    char Genre[128];
    char Artist[128];
    char Album[128];
    char Title[128];
    char Genre_mysql[128];
    char Artist_mysql[128];
    char Album_mysql[128];
    char Title_mysql[128];
    char datapath_mysql[4096];
    int PathRoot = 0;
    int BeginID = 1;
    char Str_PlaylistID[10];
    int nb_data = 0;
    unsigned long *lengths;

    // je n'insert pas le mme data dans la pile
    sprintf(query, "select * from %s where S_DataID = %d",
	    mediabox404_config->sql.streamstack,DataID);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    
    if (t) {
	mediabox404_log_debug("Insert_streamstack_data_begin:Error select DataID: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    nb_data = mysql_num_rows(res);
    mysql_free_result(res);
    
    if (nb_data == 0) {
	sprintf(query, "select S_ID from %s order by S_ID ASC LIMIT 1",
		mediabox404_config->sql.streamstack);
	
	BeginID = 1;
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_streamstack_data_begin1:Error making query: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    BeginID = atoi(row[0]);
	}
	mysql_free_result(res);
	
	sprintf(Str_PlaylistID, "%d", PlaylistID);
	sprintf(query, "select datapath.S_PathRootID,datapath.S_Path,data.S_Filename,data.S_FileType,data.S_Genre,data.S_Artist,data.S_Album,data.S_Title,data.S_Playtime  from %s data,%s datapath where data.S_ID = %d and data.S_PathID = datapath.S_ID",
		mediabox404_config->sql.data, mediabox404_config->sql.datapath,
		DataID);
	
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_streamstack1:Error making query: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
		
		
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    lengths = mysql_fetch_lengths(res);
	    PathRoot = atoi(row[0]);
	    sprintf(Path,"%.*s", (int) lengths[1], row[1] ? row[1] : "NULL");
	    sprintf(FileName,"%.*s", (int) lengths[2], 
		    row[2] ? row[2] : "NULL");
	    sprintf(FileType,"%.*s", (int) lengths[3], 
		    row[3] ? row[3] : "NULL");
	    sprintf(Genre,"%.*s", (int) lengths[4], row[4] ? row[4] : "NULL");
	    sprintf(Artist,"%.*s", (int) lengths[5], row[5] ? row[5] : "NULL");
	    sprintf(Album,"%.*s", (int) lengths[6], row[6] ? row[6] : "NULL");
	    sprintf(Title,"%.*s", (int) lengths[7], row[7] ? row[7] : "NULL");
	    Playtime = atoi(row[8]);
	    mediabox404_log_debug("Add begin %s", FileName);
	    
	    mysql_real_escape_string(mysql, Genre_mysql, Genre, strlen(Genre));
	    mysql_real_escape_string(mysql, Artist_mysql, Artist, 
				     strlen(Artist));  
	    mysql_real_escape_string(mysql, Album_mysql, Album, strlen(Album));
	    mysql_real_escape_string(mysql, Title_mysql,Title,strlen(Title));  
	   
	    if (PathRoot > 0) {
		/* Local */
		sprintf(DataPath, "%s/%s", Path, FileName);
		mysql_real_escape_string(mysql, datapath_mysql, DataPath,
					 strlen(DataPath));  
		sprintf(query, "insert into %s (S_ID,S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7,S_Argument8,S_TrackID) values (%d,0,'PLAY',now(),%d,'%s','%s','LOCAL','%s','%s','%s - %s',%d,%d,%d)", mediabox404_config->sql.streamstack,
			BeginID-1,DataID, datapath_mysql, FileType, TrackType,
			Artist_mysql, Album_mysql, Title_mysql, Playtime,
			PlaylistID, TrackID);
		//Insert_Log(mysql,0,TrackType,DataID,Genre_mysql,Artist_mysql,Album_mysql,Title_mysql,"LOCAL",FileType,Str_PlaylistID,datapath_mysql);
	    } else {
		mysql_real_escape_string(mysql, datapath_mysql, FileName, strlen(FileName));  
		sprintf(query, "insert into %s (S_ID,S_UserID,S_Code,D_DateTime,S_DataID,S_Argument1,S_Argument2,S_Argument3,S_Argument4,S_Argument5,S_Argument6,S_Argument7,S_Argument8,S_TrackID) values (%d,0,'PLAY',now(),%d,'%s','%s','REMOTE','%s','%s','%s - %s',%d,%d,%d)",
			mediabox404_config->sql.streamstack, BeginID - 1,
			DataID, datapath_mysql, FileType, TrackType,
			Artist_mysql, Album_mysql, Title_mysql, Playtime,
			PlaylistID, TrackID);
		//Insert_Log(mysql,0,TrackType,DataID,Genre_mysql,Artist_mysql,Album_mysql,Title_mysql,"REMOTE",FileType,Str_PlaylistID,datapath_mysql);
	    }
	    
	    
	    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	    if (t) {
		mediabox404_log_debug("Insert_streamstack_data_begin2:Error making query: %s",
				      mysql_error(mysql));
	    }
	}
	mysql_free_result(res);
    }
}
		
void Copy_MainPlaylist(MYSQL *mysql,
		       mediabox404_config_t *mediabox404_config,
		       unsigned int PlaylistID,
		       unsigned int TrackID)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[2048];
    char queryinsert[2048];
    
    int DataID = 0;
    int NoTrack = 0;
    int Playtime = 0;
    unsigned long *lengths;
    int ActiveTrack;
    
    sprintf(queryinsert, "delete from %s", 
	    mediabox404_config->sql.lastmainplaylist);
    
    t = mysql_real_query(mysql, queryinsert, (unsigned int)strlen(queryinsert));
    if (t) {
	mediabox404_log_debug("Copy_MainPlaylist0:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    
    sprintf(query, "select data.S_ID,data.S_Playtime from %s playlistdata,%s data where playlistdata.S_PlaylistID = %d and playlistdata.S_DataID = data.S_ID order by playlistdata.S_ID",
	    mediabox404_config->sql.playlistdata, mediabox404_config->sql.data,
	    PlaylistID);
	
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_MainPlaylist1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
	
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    ActiveTrack = 0;
	    NoTrack++;
	    lengths = mysql_fetch_lengths(res);
	    DataID = atoi(row[0]);
	    Playtime = atoi(row[1]);
	    if (TrackID == NoTrack) {
		ActiveTrack = 1;
	    }
	    // insert
	    sprintf(queryinsert, "insert into %s (S_TrackID,S_PlaylistID,S_DataID,S_Playtime,S_CurrentPlaytime,S_ActiveTrack) values (%d,%d,%d,%d,%d,%d)",
		    mediabox404_config->sql.lastmainplaylist, NoTrack,
		    PlaylistID, DataID, Playtime, 0, ActiveTrack);
	    t = mysql_real_query(mysql, queryinsert, 
				 (unsigned int)strlen(queryinsert));
	    if (t) {
		mediabox404_log_debug("Copy_MainPlaylist2:Error making query: %s",
				      mysql_error(mysql));
		return;
	    }
	    
	}
    }
    mysql_free_result(res);
}

void Copy_Playlist(MYSQL *mysql,
		   mediabox404_config_t *mediabox404_config,
		   unsigned int PlaylistID,
		   unsigned int TrackID)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[2048];
    char queryinsert[2048];
    
    int DataID = 0;
    int NoTrack = 0;
    int Playtime = 0;
    int ActiveTrack;
    unsigned long *lengths;
    
    sprintf(queryinsert, "delete from %s",
	    mediabox404_config->sql.lastplaylist);
    t = mysql_real_query(mysql, queryinsert, 
			 (unsigned int) strlen(queryinsert));
    if (t) {
	mediabox404_log_debug("Copy_Playlist0:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    
    sprintf(query, "select data.S_ID,data.S_Playtime from %s playlistdata,%s data where playlistdata.S_PlaylistID = %d and playlistdata.S_DataID = data.S_ID order by playlistdata.S_ID",
	    mediabox404_config->sql.playlistdata, mediabox404_config->sql.data,
	    PlaylistID);
    
    t = mysql_real_query(mysql, query, (unsigned int) strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_Playlist1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res=mysql_store_result(mysql);
    
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    ActiveTrack = 0;
	    NoTrack++;
	    lengths = mysql_fetch_lengths(res);
	    DataID = atoi(row[0]);
	    Playtime = atoi(row[1]);
	    if (TrackID == NoTrack) {
		ActiveTrack = 1;
	    }
	    // insert
	    sprintf(queryinsert, "insert into %s (S_TrackID,S_PlaylistID,S_DataID,S_Playtime,S_CurrentPlaytime,S_ActiveTrack) values (%d,%d,%d,%d,%d,%d)",
		    mediabox404_config->sql.lastplaylist, NoTrack,
		    PlaylistID, DataID, Playtime, 0, ActiveTrack);
	    t = mysql_real_query(mysql, queryinsert, 
				 (unsigned int)strlen(queryinsert));
	    if (t) {
		mediabox404_log_debug("Copy_Playlist2:Error making query: %s",
				      mysql_error(mysql));
		return;
	    }
	    
	}
    }
    mysql_free_result(res);
}


void Copy_Promo(MYSQL *mysql,
		mediabox404_config_t *mediabox404_config,
		unsigned int PlaylistID,
		unsigned int TrackID)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[2048];
    char queryinsert[2048];
    
    int DataID = 0;
    int NoTrack = 0;
    int Playtime = 0;
    unsigned long *lengths;
    int ActiveTrack;
    
    sprintf(queryinsert, "delete from %s", mediabox404_config->sql.lastpromo);
    t = mysql_real_query(mysql, queryinsert, 
			 (unsigned int)strlen(queryinsert));
    if (t) {
	mediabox404_log_debug("Copy_Promo0:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    
    sprintf(query, "select data.S_ID,data.S_Playtime from %s playlistdata,%s data where playlistdata.S_PlaylistID = %d and playlistdata.S_DataID = data.S_ID order by playlistdata.S_ID",
	    mediabox404_config->sql.playlistdata, mediabox404_config->sql.data,
	    PlaylistID);

   t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
   if (t) {
       mediabox404_log_debug("Copy_Promo1:Error making query: %s",
			     mysql_error(mysql));
       return;
   }
   res = mysql_store_result(mysql);
   
   if (mysql_num_rows(res) > 0) {
       while ((row = mysql_fetch_row(res))) {
	   ActiveTrack = 0;
	   NoTrack++;
	   lengths = mysql_fetch_lengths(res);
	   DataID = atoi(row[0]);
	   Playtime = atoi(row[1]);
	   if (TrackID == NoTrack) {
	       ActiveTrack = 1;
	   }
	   // insert
	   sprintf(queryinsert, "insert into %s (S_TrackID,S_PlaylistID,S_DataID,S_Playtime,S_CurrentPlaytime,S_ActiveTrack) values (%d,%d,%d,%d,%d,%d)",
		   mediabox404_config->sql.lastpromo, NoTrack, PlaylistID,
		   DataID, Playtime, 0, ActiveTrack);
	   t = mysql_real_query(mysql, queryinsert, 
				(unsigned int)strlen(queryinsert));
	   if (t) {
	       mediabox404_log_debug("Copy_Promo2:Error making query: %s",
				     mysql_error(mysql));
	       return;
	   }
	   
       }
   }
   mysql_free_result(res);
}

void Copy_Jingle(MYSQL *mysql,
		 mediabox404_config_t *mediabox404_config,
		 unsigned int PlaylistID,
		 unsigned int TrackID)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[2048];
    char queryinsert[2048];
    
    int DataID = 0;
    int NoTrack = 0;
    int Playtime = 0;
    int ActiveTrack;
    unsigned long *lengths;
    
    sprintf(queryinsert, "delete from %s", mediabox404_config->sql.lastjingle);
    t = mysql_real_query(mysql, queryinsert, 
			 (unsigned int)strlen(queryinsert));
    if (t) {
	mediabox404_log_debug("Copy_Jingle0:Error making query: %s",
			      mysql_error(mysql));
	      return;
    }
    
    sprintf(query, "select data.S_ID,data.S_Playtime from %s playlistdata,%s data where playlistdata.S_PlaylistID = %d and playlistdata.S_DataID = data.S_ID order by playlistdata.S_ID",
	    mediabox404_config->sql.playlistdata, mediabox404_config->sql.data,
	    PlaylistID);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_Jingle1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    ActiveTrack = 0;
	    NoTrack++;
	    lengths = mysql_fetch_lengths(res);
	    DataID = atoi(row[0]);
	    Playtime = atoi(row[1]);
	    if (TrackID == NoTrack) {
		ActiveTrack = 1;
	    }
	    // insert
	    sprintf(queryinsert, "insert into %s (S_TrackID,S_PlaylistID,S_DataID,S_Playtime,S_CurrentPlaytime,S_ActiveTrack) values (%d,%d,%d,%d,%d,%d)",
		    mediabox404_config->sql.lastjingle, NoTrack, PlaylistID,
		    DataID, Playtime, 0, ActiveTrack);
	    t = mysql_real_query(mysql, queryinsert, 
				 (unsigned int)strlen(queryinsert));
	    if (t) {
		mediabox404_log_debug("Copy_Jingle2:Error making query: %s",
				      mysql_error(mysql));
		return;
	    }
	    
	}
    }
    mysql_free_result(res);
}


void Delete_ProgStackID(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
			unsigned int ID)
{
    int t;
    char query[256];
    sprintf(query, "delete from %s where S_ID = %d",
	    mediabox404_config->sql.progstack,ID);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Delete_ProgStackID:Error making query: %s",
			      mysql_error(mysql));
	//return;
    }
}

void Delete_StreamStack(MYSQL *mysql, mediabox404_config_t *mediabox404_config)
{
    int t;
    char query[256];
    sprintf(query, "delete from %s", mediabox404_config->sql.streamstack);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Delete_StreamStack:Error making query: %s",
			      mysql_error(mysql));
	//return;
   }
}

void New_Program(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
		 char* datetime, unsigned int *prg_id, unsigned int *data_id, 
		 unsigned int *prg_type, unsigned int *PlayTime, 
		 char* MetaData,unsigned int *AutoProgDelay )
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[512];
    char Prgtype[12];
    unsigned long *lengths;
    sprintf(query,"select S_ID,S_Type,S_DataID,S_PlayTime,S_MetaData,S_AutoProgDelay from %s where D_DateTime = '%s' order by D_DateTime",
	    mediabox404_config->sql.programme, datetime);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    
    if (t) {
	mediabox404_log_debug("New_Program:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    *prg_type = 0;
    //printf("%d : %s",mysql_num_rows(res),query);
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	lengths = mysql_fetch_lengths(res);
	*prg_id = atoi(row[0]);
	*data_id = atoi(row[2]);
	*PlayTime = atoi(row[3]);
	sprintf(MetaData,"%.*s", (int) lengths[4], row[4] ? row[4] : ""); 
	// Metadata
	*AutoProgDelay = atoi(row[5]);
	sprintf(Prgtype,"%.*s", (int) lengths[1], row[1] ? row[1] : "NULL");
	
	if (strcmp(Prgtype,"PL")==0) {
	    *prg_type = 1;
	}
	
	if (strcmp(Prgtype,"REDIF") == 0) {
	    *prg_type = 3;
	}
	
	if (strcmp(Prgtype,"RELAY") == 0) {
	    *prg_type = 4;
	}
    }
    mysql_free_result(res);   
}

void Copy_Program(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
		  time_t *date_prg_origin, time_t *date_prg_destination)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[1024];
    struct tm *datetime;
    char str_date_destination[32]; /* YYYY/MM/DD */
    char str_time_destination[32]; /* 00:00:00 */
    char str_datetime_destination[32]; /* 00:00:00 */
    char str_datetime_origin[32]; /* 00:00:00 */
    unsigned long *lengths;
    
    
    datetime = localtime(date_prg_destination);

    sprintf(str_date_destination, "%04d-%02d-%02d", 1900+datetime->tm_year,
	    datetime->tm_mon+1, datetime->tm_mday);
    sprintf(str_time_destination, "%02d:%02d:%02d", datetime->tm_hour,
	    datetime->tm_min, datetime->tm_sec);
    sprintf(str_datetime_destination, "%04d-%02d-%02d %02d:%02d:%02d",
	    1900+datetime->tm_year, datetime->tm_mon+1, datetime->tm_mday,
	    datetime->tm_hour, datetime->tm_min, datetime->tm_sec);

    datetime = localtime(date_prg_origin);
    sprintf(str_datetime_origin, "%04d-%02d-%02d %02d:%02d:%02d",
	    1900+datetime->tm_year, datetime->tm_mon+1,
	    datetime->tm_mday, datetime->tm_hour,
	    datetime->tm_min,datetime->tm_sec);
    
    sprintf(query, "select S_Type,S_ID,S_Title,S_ShortDescription,S_Description,S_DataID,S_Playtime,S_Color,S_URL,S_Image,S_MetaData,S_AutoProgDelay,S_JingleID,S_JingleNb,S_JingleDelay  from %s where D_DateTime = '%s'",
	    mediabox404_config->sql.programme, str_datetime_origin);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Copy_Program:Select Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
	
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	lengths = mysql_fetch_lengths(res);
	
	sprintf(query, "insert into %s values ('%s','%s','%s','%s',%s,'%s','%s','%s',%s,%s,'%s','%s','%s','%s',%s,%s,%s,%s)",
		mediabox404_config->sql.programme, str_date_destination,
		str_time_destination, str_datetime_destination, row[0], row[1],
		row[2], row[3], row[4], row[5], row[6], row[7], row[8], row[9],
		row[10], row[11], row[12], row[13], row[14]);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));

	mediabox404_log_debug("reprogrammation automatique de %s",
			      str_datetime_destination);
	if (t) {
	    mediabox404_log_debug("Copy_Program:Error making query: %s",
				  mysql_error(mysql));
	    return;
	}
	}

}

void AddMetaData(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
		 char* MetaData)
{
    
    int t;
    char MetaData_mysql[1024];
    char query[1024];
    
    sprintf(query,"delete from %s",mediabox404_config->sql.metadata);
    
    t=mysql_real_query(mysql,query,(unsigned int) strlen(query));
    
    if (t) {
	mediabox404_log_debug("AddMetaData0:Error making query: %s",
			      mysql_error(mysql));
	//return;
    }
	
    mysql_real_escape_string(mysql, MetaData_mysql, MetaData, 
			     strlen(MetaData));
    sprintf(query, "insert into %s (S_Data) values ('%s')",
	    mediabox404_config->sql.metadata,MetaData_mysql);
    t = mysql_real_query(mysql, query, (unsigned int) strlen(query));
    mediabox404_log_debug("AddMetaData = %s",MetaData);
    if (t) {
	mediabox404_log_debug("AddMetaData:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
}

void Update_CurrentPL(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
		      char* Type_stream, unsigned int user_id, 
		      unsigned int playlist_id, unsigned int track_id, 
		      unsigned int data_id,char* URL)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    int PlayTime = 0;
    char query[512];
    
    sprintf(query, "delete from %s", 
	    mediabox404_config->sql.currentplaylisttype);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Update_CurrentPL0:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
	
    sprintf(query, "select S_Playtime from %s where s_ID = %d",
	    mediabox404_config->sql.data, data_id);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Update_CurrentPL1:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	PlayTime = atoi(row[0]);
    }
    mysql_free_result(res);
    
    sprintf(query, "insert into %s (S_Type,S_UserID,S_PlaylistID,S_TrackID,S_DataID,S_Playtime,S_CurrentPlaytime,S_URL) values ('%s',%d,%d,%d,%d,%d,%d,'%s')",
	    mediabox404_config->sql.currentplaylisttype, Type_stream, user_id,
	    playlist_id, track_id, data_id, PlayTime, 0, URL);
    
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Update_CurrentPL3:Error making query: %s",
			      mysql_error(mysql));
	return;
    }
    
}

void Insert_Main_PL(MYSQL *mysql, mediabox404_config_t *mediabox404_config, 
		    int *nb_control_play)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[4096];
    int Main_PL_ID;
    int LastDataID = 0;
    int LastTrackID = 0;
    int LastTrackID2 = 0;
    int No_track = 0;
    int NewTrackID = 0;
    int NewTrackID2 = 0;
    int NewDataID = 0;
    int NewDataID2 = 0;
    int BeginDataID = 0;
    
    
    // rcupration de l'ID de PL principale
    sprintf(query,"select S_ID from %s where S_Type = 'MAIN'",mediabox404_config->sql.playlist);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Main_PL:Error select MAIN PL: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    Main_PL_ID = 0;
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	Main_PL_ID = atoi(row[0]);
    }
    mysql_free_result(res);
   
    // il existe une PL Main
    if (Main_PL_ID > 0) {
	// rcupration de l'ID de l'ancienne track
	sprintf(query, "select S_DataID,S_TrackID from %s where S_PlaylistID = %d and S_ActiveTrack = 1",
		mediabox404_config->sql.lastmainplaylist, Main_PL_ID);
	t = mysql_real_query(mysql,query,(unsigned int) strlen(query));

	if (t) {
	    mediabox404_log_debug("Insert_Main_PL : Error select Last Track MAIN PL: %s",
				  mysql_error(mysql));
	    return;
	}

	res = mysql_store_result(mysql);
	LastDataID = 0;
	LastTrackID = 0;
	LastTrackID2 = 0;
	
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    LastDataID = atoi(row[0]);
	    LastTrackID = atoi(row[1]);
	}
	mysql_free_result(res);
	
	// chercher le data ID dans la Playlist --> Track data ID
	No_track = 0;
	NewTrackID = 0;
	NewTrackID2 = 0;
	NewDataID = 0;
	NewDataID2 = 0;
	BeginDataID = 0;
	
	sprintf(query, "select S_DataID from %s where S_PlaylistID = %d order by S_ID",
		mediabox404_config->sql.playlistdata, Main_PL_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	
	if (t) {
	    mediabox404_log_debug("Insert_Main_PL:Error select Last Track MAIN PL: %s",
				  mysql_error(mysql));
	    return;
	}

	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    while ((row = mysql_fetch_row(res))) {
		No_track++;
		if (LastTrackID == No_track-1) {
		    NewTrackID2 =  No_track;
		    NewDataID2 = atoi(row[0]);
		}
		if ((LastTrackID2 != 0) && (NewTrackID == 0)) {
		    NewTrackID =  No_track;
		    NewDataID =  atoi(row[0]);
		}
		if (LastDataID == atoi(row[0])) {
		    LastTrackID2 = No_track; /* found previous track */
		}
		if (No_track == 1) {
		    BeginDataID = atoi(row[0]);
		}
	    }
	}
	mysql_free_result(res);
	
	if (NewTrackID == 0) {
	    /* end of play, loop again */
	    NewDataID = BeginDataID;	
	    NewTrackID = 1;	
	}
	if (LastTrackID == 0) {
	    /* Track + 1 */
	    NewDataID = NewDataID2;	
	    NewTrackID = NewTrackID2;	
	}
	
        /*mediabox404_log_debug(" --> Insert_Main_PL : TrackID:%d, DataID:%d",NewTrackID,NewDataID);*/
	/* Insert Data into t_streamstack */
	Insert_streamstack_data(mysql, mediabox404_config, Main_PL_ID,
				NewDataID, NewTrackID, "MAIN", 
				nb_control_play);
	/* copy t_playlistdata -> t_lastmainplaylist 
	   with ActiveTrack = Track ID */
	Copy_MainPlaylist(mysql, mediabox404_config, Main_PL_ID, NewTrackID);
	// Current PL
	//Update_CurrentPL(mysql,"MAIN",0,Main_PL_ID,NewTrackID,NewDataID,"");
	
    }
    
}

void Insert_Jingle_Prg_24(MYSQL *mysql, 
			  mediabox404_config_t *mediabox404_config,
			  time_t BeginDate)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int dif_jingle, prg_trouve, i, t, JingleID, JingleNb,
	JingleDelay, Prg_ID, No_Jingle;
    time_t EndDate;
    time_t ProgDate;
    time_t ProgDateSrc;
    char query[4096];
    struct tm *datetime;
    char str_datetime_begin[32];
    char str_datetime_end[32];
    char str_datetime_prg[32];
    char str_datetime_prg_src[32];
    unsigned long *lengths;

    dif_jingle = No_Jingle = 0;
    
    datetime = localtime(&BeginDate);
    sprintf(str_datetime_begin, "%04d-%02d-%02d %02d:%02d:%02d",
	    1900+datetime->tm_year, datetime->tm_mon+1, datetime->tm_mday,
	    datetime->tm_hour, datetime->tm_min, datetime->tm_sec);

    EndDate = BeginDate + 24*60*60;
    datetime = localtime(&EndDate);
    sprintf(str_datetime_end, "%04d-%02d-%02d %02d:%02d:%02d",
	    1900+datetime->tm_year, datetime->tm_mon+1, datetime->tm_mday,
	    datetime->tm_hour, datetime->tm_min, datetime->tm_sec);
	
    // rcupration des programmes avec un jingle sur 24h
    sprintf(query, "select D_DateTime,S_JingleID,S_JingleNb,S_JingleDelay,S_ID from %s where D_DateTime between '%s' and '%s' and S_JingleID > 0 order by D_DateTime",
	    mediabox404_config->sql.programme, str_datetime_begin,
	    str_datetime_end);

    t = mysql_real_query(mysql, query, (unsigned int) strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Jingle_Prg_24:Error select JINGLE PRG: %s",
			      mysql_error(mysql));
	return;
    }
    
    res = mysql_store_result(mysql);
    if (mysql_num_rows(res) > 0) {
	while ((row = mysql_fetch_row(res))) {
	    
	    lengths = mysql_fetch_lengths(res);
	    sprintf(str_datetime_prg,"%.*s", (int) lengths[0], row[0] ? row[0] : ""); // DateTime du programme
	    JingleID = atoi(row[1]);
	    JingleNb = atoi(row[2]);
	    JingleDelay = atoi(row[3]);
	    Prg_ID = atoi(row[4]);
	    
	    // recherche du dbut du programme
	    ProgDate = BeginDate;
	    prg_trouve = 0;
	    for (i = 0; i < (24*60); i += mediabox404_config->program_timing) {
		if (prg_trouve == 0) {
		    ProgDate = BeginDate + i*60;
		    datetime = localtime(&ProgDate);
		    sprintf(str_datetime_prg_src, "%04d-%02d-%02d %02d:%02d:%02d", 1900+datetime->tm_year, datetime->tm_mon+1, datetime->tm_mday, 
			    datetime->tm_hour, datetime->tm_min,
			    datetime->tm_sec);
		    if (strcmp(str_datetime_prg_src, str_datetime_prg) ==0 ) 
			prg_trouve = 1;
		}
	    }
	    //
	    if (prg_trouve == 1) {
		dif_jingle = 0;
		No_Jingle = 0;
		for (i = 0; i<JingleNb;i++) {
		    if (dif_jingle == 0) {
			No_Jingle++;
			ProgDateSrc = ProgDate - (i*JingleDelay*60);
			datetime = localtime(&ProgDateSrc);
			sprintf(str_datetime_prg_src, 
				"%04d-%02d-%02d %02d:%02d:%02d",
				1900+datetime->tm_year, datetime->tm_mon+1,
				datetime->tm_mday, datetime->tm_hour,
				datetime->tm_min, datetime->tm_sec);
			if (strcmp(str_datetime_prg_src, str_datetime_begin)
			    == 0) 
			    dif_jingle = 1;
		    }
		}
	    }
	    if (dif_jingle == 1) {
		Insert_streamstack_data_begin(mysql, mediabox404_config,
					      Prg_ID, JingleID, No_Jingle,
					      "JINGLE");
	    }
	    
	}
    }
    mysql_free_result(res);
}

void Insert_Jingle(MYSQL *mysql, mediabox404_config_t *mediabox404_config)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[4096];
    int LastDataID = 0;
    int LastTrackID = 0;
    int LastTrackID2 = 0;
    int No_track = 0;
    int NewTrackID = 0;
    int NewTrackID2 = 0;
    int NewDataID = 0;
    int NewDataID2 = 0;
    int BeginDataID = 0;
    
    // rcupration de l'ID de PL principale
    sprintf(query,"select S_ID from %s where S_Type = 'JINGLE'",
	    mediabox404_config->sql.playlist);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));

    if (t) {
	mediabox404_log_debug("Insert_Jingle:Error select JINGLE: %s",
			      mysql_error(mysql));
	return;
    }
    
    res = mysql_store_result(mysql);
    int Jingle_ID = 0;
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	Jingle_ID = atoi(row[0]);
    }
    mysql_free_result(res);
    
    /* there is a Main PL */
    if (Jingle_ID > 0) {
	/* Get the previous track ID */ 
	sprintf(query, "select S_DataID,S_TrackID from %s where S_PlaylistID = %d and S_ActiveTrack = 1",
		mediabox404_config->sql.lastjingle, Jingle_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	
	if (t) {
	    mediabox404_log_debug("Insert_Jingle:Error select Last Track JINGLE: %s",
				  mysql_error(mysql));
	    return;
	}
	
	res = mysql_store_result(mysql);
	LastDataID = 0;
	LastTrackID = 0;
	LastTrackID2 = 0;
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    LastDataID = atoi(row[0]);
	    LastTrackID = atoi(row[1]);
	}
	mysql_free_result(res);
	
	// chercher le data ID dans la Playlist --> Track data ID
	No_track = 0;
	NewTrackID = 0;
	NewTrackID2 = 0;
	NewDataID = 0;
	NewDataID2 = 0;
	BeginDataID = 0;
	
	sprintf(query, "select S_DataID from %s where S_PlaylistID = %d order by S_ID",
		mediabox404_config->sql.playlistdata, Jingle_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Jingle:Error select Last Track JINGLE: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    while ((row = mysql_fetch_row(res))) {
		No_track++;
		if (LastTrackID == No_track-1) {
		    NewTrackID2 =  No_track;
		    NewDataID2 = atoi(row[0]);
		}
		if ((LastTrackID2 != 0) && (NewTrackID == 0)) {
		    NewTrackID =  No_track;
		    NewDataID =  atoi(row[0]);
		}
		if (LastDataID == atoi(row[0])) {
		    LastTrackID2 = No_track; /* found previous track */
		} 
		if (No_track == 1) {
		    BeginDataID = atoi(row[0]);
		}
	    }
	}
	mysql_free_result(res);
	
	if (NewTrackID == 0) {
	    /* end of play so loop again */
	    NewDataID = BeginDataID;	
	    NewTrackID = 1;	
	}
	if (LastTrackID == 0) {
	    /* track + 1 */
	    NewDataID = NewDataID2;	
	    NewTrackID = NewTrackID2;	
	}
	
	/*mediabox404_log_debug(" --> Insert_Jingle_PL : TrackID:%d, DataID:%d",NewTrackID,NewDataID);*/
	/* Insert Data into t_streamstack */
	Insert_streamstack_data_begin(mysql, mediabox404_config, Jingle_ID,
				      NewDataID,NewTrackID,"JINGLE");
	/* copy t_playlistdata -> t_lastmainplaylist 
	   with ActiveTrack = Track ID*/
	Copy_Jingle(mysql, mediabox404_config, Jingle_ID, NewTrackID);
   }
   
}

void Insert_Jingle_end(MYSQL *mysql, mediabox404_config_t *mediabox404_config,
		       int *nb_control_play)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[4096];
    int LastDataID = 0;
    int LastTrackID = 0;
    int LastTrackID2 = 0;
    int No_track = 0;
    int NewTrackID = 0;
    int NewTrackID2 = 0;
    int NewDataID = 0;
    int NewDataID2 = 0;
    int BeginDataID = 0;
    
    /* Get main playlist ID */
    sprintf(query, "select S_ID from %s where S_Type = 'JINGLE'",
	    mediabox404_config->sql.playlist);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Jingle:Error select JINGLE: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    int Jingle_ID = 0;
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	Jingle_ID = atoi(row[0]);
    }
    mysql_free_result(res);
    
    // il existe une PL Main
    if (Jingle_ID > 0) {
	// rcupration de l'ID de l'ancienne track
	sprintf(query,"select S_DataID,S_TrackID from %s where S_PlaylistID = %d and S_ActiveTrack = 1",
		mediabox404_config->sql.lastjingle, Jingle_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	
	if (t) {
	    mediabox404_log_debug("Insert_Jingle:Error select Last Track JINGLE: %s",
				  mysql_error(mysql));
	    return;
	}
	
	res = mysql_store_result(mysql);
	LastDataID = 0;
	LastTrackID = 0;
	LastTrackID2 = 0;
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    LastDataID = atoi(row[0]);
	    LastTrackID = atoi(row[1]);
	}
	mysql_free_result(res);
	
	// chercher le data ID dans la Playlist --> Track data ID
	No_track = 0;
	NewTrackID = 0;
	NewTrackID2 = 0;
	NewDataID = 0;
	NewDataID2 = 0;
	BeginDataID = 0;
	sprintf(query, "select S_DataID from %s where S_PlaylistID = %d order by S_ID",
		mediabox404_config->sql.playlistdata, Jingle_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Jingle_end1:Error select Last Track JINGLE: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    while ((row = mysql_fetch_row(res))) {
		No_track++;
		if (LastTrackID == No_track-1) {
		    NewTrackID2 =  No_track;
		    NewDataID2 = atoi(row[0]);
		}
		if ((LastTrackID2 != 0) && (NewTrackID == 0)) {
		    NewTrackID =  No_track;
		    NewDataID =  atoi(row[0]);
		}
		if (LastDataID == atoi(row[0])) {
		    LastTrackID2 = No_track; /* found previous track */
		} 
		if (No_track == 1) {
		    BeginDataID = atoi(row[0]);
		}
	    }
	}
	mysql_free_result(res);
	
	if (NewTrackID == 0) {
	    /* end of play so loop again */
	    NewDataID = BeginDataID;	
	    NewTrackID = 1;	
	}
	if (LastTrackID == 0) {
	    /* Track + 1 */
	    NewDataID = NewDataID2;	
	    NewTrackID = NewTrackID2;	
	}
	
        /*mediabox404_log_debug(" --> Insert_Jingle_PL_end2 : TrackID:%d, DataID:%d",NewTrackID,NewDataID);*/
	/* Insert Data into t_streamstack */
	Insert_streamstack_data(mysql, mediabox404_config, Jingle_ID,
				NewDataID, NewTrackID, "JINGLE",
				nb_control_play);
	/* copy t_playlistdata -> t_lastmainplaylist 
	   with ActiveTrack = Track ID */
	Copy_Jingle(mysql, mediabox404_config, Jingle_ID, NewTrackID);
   }
   
}


void Insert_Promo(MYSQL *mysql, mediabox404_config_t *mediabox404_config)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[4096];
    int LastDataID = 0;
    int LastTrackID = 0;
    int LastTrackID2 = 0;
    int No_track = 0;
    int NewTrackID = 0;
    int NewTrackID2 = 0;
    int NewDataID = 0;
    int NewDataID2 = 0;
    int BeginDataID = 0;
    
    // rcupration de l'ID de PL principale
    sprintf(query, "select S_ID from %s where S_Type = 'PROMO'",
	    mediabox404_config->sql.playlist);
    t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Promo:Error select PROMO: %s",
			      mysql_error(mysql));
	return;
    }
    res = mysql_store_result(mysql);
    int Promo_ID = 0;
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	Promo_ID = atoi(row[0]);
    }
    mysql_free_result(res);
   
    /* there is a main PL */
    if (Promo_ID > 0) {
	// rcupration de l'ID de l'ancienne track
	sprintf(query, "select S_DataID,S_TrackID from %s where S_PlaylistID = %d and S_ActiveTrack = 1",
		mediabox404_config->sql.lastpromo, Promo_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Promo:Error select Last Track PROMO: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	LastDataID = 0;
	LastTrackID = 0;
	LastTrackID2 = 0;
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    LastDataID = atoi(row[0]);
	    LastTrackID = atoi(row[1]);
	}
	mysql_free_result(res);
	
	// chercher le data ID dans la Playlist --> Track data ID
	No_track = 0;
	NewTrackID = 0;
	NewTrackID2 = 0;
	NewDataID = 0;
	NewDataID2 = 0;
	BeginDataID = 0;
	sprintf(query, "select S_DataID from %s where S_PlaylistID = %d order by S_ID",
		mediabox404_config->sql.playlistdata, Promo_ID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Promo:Error select Last Track PROMO: %s",
				  mysql_error(mysql));
	    return;
	}
	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    while ((row = mysql_fetch_row(res))) {
		No_track++;
		if (LastTrackID == No_track-1) {
		    NewTrackID2 =  No_track;
		    NewDataID2 = atoi(row[0]);
		}
		if ((LastTrackID2 != 0) && (NewTrackID == 0)) {
		    NewTrackID =  No_track;
		    NewDataID =  atoi(row[0]);
		}
		if (LastDataID == atoi(row[0])) {
		    LastTrackID2 = No_track; /* i found the previous track */
		} 
		if (No_track == 1) {
		    BeginDataID = atoi(row[0]);
		}
	    }
	}
	mysql_free_result(res);
	
	if (NewTrackID == 0) {
	    /* end of play so loop again */
	    NewDataID = BeginDataID;	
	    NewTrackID = 1;	
	}
	if (LastTrackID == 0) {
	    /* Track + 1 */
	    NewDataID = NewDataID2;	
	    NewTrackID = NewTrackID2;	
	}
	
        /*mediabox404_log_debug(" --> Insert_Promo_PL : TrackID:%d, DataID:%d",NewTrackID,NewDataID);*/
	/* Insert Data into t_streamstack */
	Insert_streamstack_data_begin(mysql, mediabox404_config, Promo_ID,
				      NewDataID, NewTrackID, "PROMO");
	/* copy t_playlistdata -> t_lastmainplaylist 
	   with ActiveTrack = Track ID */
	Copy_Promo(mysql, mediabox404_config, Promo_ID, NewTrackID);
	//Update_CurrentPL(mysql,"PROMO",0,Promo_ID,NewTrackID,NewDataID,"");
   }
   
}

unsigned int Insert_PL(MYSQL *mysql,
		       mediabox404_config_t *mediabox404_config,
		       unsigned int PlaylistID,
		       int *nb_control_play)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    int t;
    char query[4096];
    int NewTrackID = 0;
    int LastDataID = 0;
    int LastTrackID = 0;
    int LastTrackID2 = 0;
    int No_track = 0;
    int NewTrackID2 = 0;
    int NewDataID = 0;
    int NewDataID2 = 0;
    int BeginDataID = 0;
    
    if (PlaylistID > 0) {
	// rcupration de l'ID de l'ancienne track
	sprintf(query, "select S_DataID,S_TrackID from %s where S_PlaylistID = %d and S_ActiveTrack = 1", 
		mediabox404_config->sql.lastplaylist, PlaylistID);
	t = mysql_real_query(mysql, query, (unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Main_PL:Error select Last Track PL: %s",
				  mysql_error(mysql));
	    return 0;
	}
	res = mysql_store_result(mysql);
	LastDataID = 0;
	LastTrackID = 0;
	LastTrackID2 = 0;
	if (mysql_num_rows(res) > 0) {
	    row = mysql_fetch_row(res);
	    LastDataID = atoi(row[0]);
	    LastTrackID = atoi(row[1]);
	}
	mysql_free_result(res);
	
	// chercher le data ID dans la Playlist --> Track data ID
	No_track = 0;
	NewTrackID2 = 0;
	NewDataID = 0;
	NewDataID2 = 0;
	BeginDataID = 0;
	sprintf(query, "select S_DataID from %s where S_PlaylistID = %d order by S_ID", 
		mediabox404_config->sql.playlistdata, PlaylistID);
	t = mysql_real_query(mysql, query,(unsigned int)strlen(query));
	if (t) {
	    mediabox404_log_debug("Insert_Main_PL:Error select Last Track MAIN PL: %s",
				  mysql_error(mysql));
	    return 0;
	}
	res = mysql_store_result(mysql);
	if (mysql_num_rows(res) > 0) {
	    while ((row = mysql_fetch_row(res))) {
		No_track++;
		if (LastTrackID == No_track-1) {
		    NewTrackID2 =  No_track;
		    NewDataID2 = atoi(row[0]);
		}
		if ((LastTrackID2 != 0) && (NewTrackID == 0)) {
		    NewTrackID =  No_track;
		    NewDataID =  atoi(row[0]);
		}
		if (LastDataID == atoi(row[0])) {
		    LastTrackID2 = No_track; /* found previous track */
		}
		if (No_track == 1) {
		    BeginDataID = atoi(row[0]);
		}
	    }
	}
	mysql_free_result(res);
	
	if (LastTrackID == 0) {
	    /* track + 1 */
	    NewDataID = NewDataID2;	
	    NewTrackID = NewTrackID2;	
	}
	
        /*mediabox404_log_debug(" --> Insert_PL : TrackID:%d, DataID:%d",NewTrackID,NewDataID);*/
	/* Insert Data into t_streamstack */
	Insert_streamstack_data(mysql, mediabox404_config, PlaylistID,
				NewDataID, NewTrackID, "PL", nb_control_play);
	/*copy t_playlistdata -> t_lastmainplaylist 
	  with ActiveTrack = Track ID*/
	Copy_Playlist(mysql, mediabox404_config, PlaylistID, NewTrackID);
	//Update_CurrentPL(mysql,"PL",0,PlaylistID,NewTrackID,NewDataID,"");
	
    }
return NewTrackID;   
}

unsigned int Insert_Relay(MYSQL *mysql,
			  mediabox404_config_t *mediabox404_config,
			  unsigned int LiveID,
			  unsigned int PlayTime)
{
    MYSQL_RES *res;
    MYSQL_ROW row;
    unsigned long *lengths;
    int t,insert_res;
    char query[4096];
    char LIVE_URL[512],LIVE_Format[5];
    unsigned int UserLIVE_ID, LIVE_Bitrate, LIVE_Frequence,
	LIVE_NbCanal, LIVE_NbReconnect;

    insert_res = UserLIVE_ID = LIVE_Bitrate = LIVE_Frequence = 
	LIVE_NbCanal = LIVE_NbReconnect = 0;

    if (LiveID <= 0) {
	return insert_res;
    }

    // rcupration de l'ID de l'ancienne track
    sprintf(query, "select LIVE_URL,LIVE_FORMAT,LIVE_BITRATE,LIVE_FREQUENCE,LIVE_CANAL,LIVE_RECONNECT,S_UserID from %s where S_ID = %d",
	    mediabox404_config->sql.live, LiveID);
    t = mysql_real_query(mysql,query,(unsigned int) strlen(query));
    if (t) {
	mediabox404_log_debug("Insert_Relay:Error select Last Track PL: %s",
			      mysql_error(mysql));
	return 0;
    }
    res = mysql_store_result(mysql);
    if (mysql_num_rows(res) > 0) {
	row = mysql_fetch_row(res);
	lengths = mysql_fetch_lengths(res);
	// les arguments ne sont pas vide
	if ((lengths[0]>0) && (lengths[1]>0) && 
	    (lengths[2]>0) && (lengths[3]>0) && 
	    (lengths[4]>0) && (lengths[6]>0)) {
	    sprintf(LIVE_URL,"%.*s", (int) lengths[0], 
		    row[0] ? row[0] : "NULL"); // URL
	    sprintf(LIVE_Format,"%.*s", (int) lengths[1], 
		    row[1] ? row[1] : "NULL"); // Format
	    LIVE_Bitrate = atoi(row[2]);
	    LIVE_Frequence = atoi(row[3]);
	    LIVE_NbCanal = atoi(row[4]);
	    
	    if  (lengths[5] > 0) {
		LIVE_NbReconnect = atoi(row[5]);
	    }
	    else 
		LIVE_NbReconnect = 0;
	    UserLIVE_ID = atoi(row[6]);
	    insert_res = 1;
	}
    }
    mysql_free_result(res);
    if (insert_res == 1) {
	Insert_streamstack_relay(mysql, mediabox404_config, UserLIVE_ID,
				 LiveID, LIVE_URL, LIVE_Format, 
				 LIVE_Bitrate, LIVE_Frequence, 
				 LIVE_NbCanal, LIVE_NbReconnect, PlayTime);
	//mediabox404_log_debug(" --> Insert_Relay : %s",LIVE_URL);
    }
    
    return insert_res;   
}
