/**
* @package MediaBox404_prg
* @copyright (C) 2004 - 2005 erreur404.org
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* MediaBox404 is Free Software
* @author vortex@erreur404.org
* $Id: scheduler404.c,v 1.2 2005/07/18 18:38:18 bedlam Exp $
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <mysql/mysql.h>
#include "scheduler404.h"
#include "xml_config.h"
#include "log.h"
#include "mysql_utils.h"
#include "util.h"

#define BUFSIZE 4096

mediabox404_config_t mediabox404_config;

int main(int argc, char *argv[])
{
    time_t timer = 0;
    struct tm *today;
    
    time_t NextAutoProgramme = 0;
    time_t NextScanProgramme = 0;
    time_t NextScanJingle = 0;
    time_t NextScanPromo = 0;
    time_t EndRelay = 0;
    char query_streamstack[255];
    char query_prgstack[255];
    int CurrentPlaylist = 0;
    int CurrentData = 0;
    int StreamType = MAIN_STREAM; /* 0:MAIN,1:PL,2:REDIF,3:LIVE,4:RELAY */
    int ScanPrg = 0; /* how many seconds to scan t_progstack stack */
    int flag_stop_relay = 0;
    int flag_doublon_promo = 0;
    int flag_doublon_jingle = 0;
    int flag_doublon_jingle_prg = 0;
    unsigned int AutoProgDelay;
    unsigned int control;
    
    char MetaData[512];
    
    unsigned int StackPrgID, UserPrgID, DataPrgID, LIVE_Bitrate, 
	LIVE_Frequence, LIVE_NbCanal, LIVE_NbReconnect, PlayTime;
    char CODE[10];
    char date_prg[32];
    char ARG[8][512];
    MYSQL_RES *res;
    MYSQL_ROW row;
    int query_ok;
    int wait = 1;
    int i;
    int nb_control_play = 0;
    unsigned long *lengths;
    unsigned int data_id,prg_id,prg_type;
#define TIMINGVALUELEN 22
    int TimingValue[TIMINGVALUELEN] = {1, 2, 3, 4, 5, 6, 8, 9, 10, 12, 15, 16, 
				       18, 20, 24, 30, 32, 36, 40, 45, 48, 60};
    
    MYSQL mysql;
    
    mediabox404_config.verbose = 1;
    
    if (argc != 2) {
	mediabox404_log("Define xml config file !!!");
	mediabox404_log("IE: mediabox404_radio_prg mediabox404_radio_prg.xml");
	mediabox404_log("Exit Programmation Mediabox404_audio");
	
	return EXIT_SUCCESS;
    }
  
  	
    /* Parse the options in the config file, and the command line */
    mediabox404_xml_parse_config_file (&mediabox404_config, argv[1]);
    
    mysql_init(&mysql);
    mysql_options(&mysql, MYSQL_READ_DEFAULT_GROUP, 
		  mediabox404_config.sql.mysql_options);
    
    if (!mediabox404_config.sql.usocket) {
	/* connect using host parameter */
	if (!mysql_real_connect(&mysql, mediabox404_config.sql.hostname, 
				mediabox404_config.sql.user, 
				mediabox404_config.sql.password, 
				mediabox404_config.sql.database, 0, NULL,0)) {
	    mediabox404_log ("%s : Cannot connect port to sql database ! hostname:%s user:%s password:%s database:%s %d",
			     mysql_error(&mysql),
			     mediabox404_config.sql.hostname, 
			     mediabox404_config.sql.user, 
			     mediabox404_config.sql.password, 
			     mediabox404_config.sql.database,
			     mediabox404_config.sql.port);
	    exit(0);
	}
    } else {
	/* connect using socket parameter */
	if (!mysql_real_connect(&mysql, NULL, mediabox404_config.sql.user, 
				mediabox404_config.sql.password, 
				mediabox404_config.sql.database,
				mediabox404_config.sql.port, 
				mediabox404_config.sql.usocket, 0)) {
	    mediabox404_log ("%s : Cannot connect usocket to sql database ! hostname:%s user:%s password:%s database:%s %d",
			     mysql_error(&mysql),
			     mediabox404_config.sql.hostname, 
			     mediabox404_config.sql.user, 
			     mediabox404_config.sql.password, 
			     mediabox404_config.sql.database,
			     mediabox404_config.sql.usocket);
	    exit(0);
	}
    }
    
    mediabox404_log("Starting %s",
		    mediabox404_config.sql.mysql_options);
    mediabox404_log_debug("Connected...");
    mediabox404_log_debug("Timming control...");
    
    /* find the timing value */
    control = 0;
    for (i = 0 ; i < TIMINGVALUELEN; i++) { 
	if (TimingValue[i] == mediabox404_config.program_timing) {
	    control++;
	}
    }
    if (control != 1) { 
	mediabox404_log_debug("Program_timing error : %d not in {1,2,3,4,5,6,8,9,10,12,15,16,18,20,24,30,32,36,40,45,48,60} list",
			      mediabox404_config.program_timing);
    }

    if ((mediabox404_config.jingle_timing % 
	 mediabox404_config.program_timing) == 0) {
	control++;
    } else { 
	mediabox404_log_debug("Jingle_timing error : %d not mod program_timing %d",
			      mediabox404_config.jingle_timing,
			      mediabox404_config.program_timing);
    }
    
    if ((mediabox404_config.promo_timing % 
	 mediabox404_config.program_timing)==0) {
	control++;
    } else { 
	mediabox404_log_debug("Promo_timing error : %d not mod program_timing %d",
			      mediabox404_config.promo_timing,
			      mediabox404_config.program_timing);
    }
    
    if (control != 3) {
	mediabox404_log("Timming control error ...");
	mediabox404_log("Exit Programmation Mediabox404_audio");
    
	return EXIT_SUCCESS;
    }

    
    mediabox404_log_debug("Timming control... ok");
    
    time(&timer);
    
    today = localtime(&timer);
    today->tm_sec = 0;
    today->tm_min = 0;
    NextScanProgramme = mktime(today);
    NextScanJingle = mktime(today);
    NextScanPromo = mktime(today);
    
    /* launch a jingle when starting */
    mediabox404_log_debug("Purge streamstack");
    Delete_StreamStack(&mysql, &mediabox404_config);
    Insert_Jingle(&mysql, &mediabox404_config);
    
    while (NextScanProgramme <= timer) { 
	NextScanProgramme = NextScanProgramme + 
	    (mediabox404_config.program_timing * 60);
    }
    
    while (NextScanJingle <= timer) {
	NextScanJingle = NextScanJingle + 
	    (mediabox404_config.jingle_timing * 60);
    }
    
    while (NextScanPromo <= timer) {
	NextScanPromo = NextScanPromo + 
	    (mediabox404_config.promo_timing * 60);
    }
    
    while (1) {
	
	flag_stop_relay = 0;
	time( &timer );
	today = localtime( &timer );
	sprintf(date_prg, "%04d-%02d-%02d %02d:%02d:%02d",
		1900+today->tm_year, today->tm_mon+1,
		today->tm_mday, today->tm_hour,
		today->tm_min, today->tm_sec);
	
	if (timer >= NextScanPromo) {
	    if (flag_doublon_promo == 0) {
		flag_doublon_promo = 1;
		if (StreamType == MAIN_STREAM) {
		    Insert_Promo(&mysql, &mediabox404_config);
		}
		today = localtime(&timer);
		today->tm_sec = 0;
		today->tm_min = 0;
		NextScanPromo = mktime(today);
		while (NextScanPromo <= timer) {
		    NextScanPromo = NextScanPromo + 
			(mediabox404_config.promo_timing * 60);
		}
		mediabox404_log_debug("NextScanPromo\n");
	    }
	}
	if (timer >= NextScanJingle) {
	    if (flag_doublon_jingle == 0) {
		flag_doublon_jingle = 1;
		if (StreamType == MAIN_STREAM) {
		    Insert_Jingle(&mysql, &mediabox404_config);
		}	 
		today = localtime(&timer);
		today->tm_sec = 0;
		today->tm_min = 0;
		NextScanJingle = mktime(today);
		while (NextScanJingle <= timer) {
		    NextScanJingle = NextScanJingle + 
			(mediabox404_config.jingle_timing * 60);
		}
		mediabox404_log_debug("NextScanJingle");
	    }
	}
	if (timer >= NextScanProgramme) {
	    // les jingle des prochains programmes sur 24h
	    if ((StreamType == MAIN_STREAM) && 
		(flag_doublon_jingle_prg == 0)) {
		flag_doublon_jingle_prg = 1;
		mediabox404_log_debug("Insert_Jingle_Prg_24");
		Insert_Jingle_Prg_24(&mysql, &mediabox404_config,
				     NextScanProgramme);
		mediabox404_log_debug("Insert_Jingle_Prg_24 : ok");
	    }	 
	    prg_id = 0;
	    mediabox404_log_debug("New_Program");
	    New_Program(&mysql, &mediabox404_config, date_prg,
			&prg_id, &data_id, &prg_type, &PlayTime,
			MetaData, &AutoProgDelay);
	    mediabox404_log_debug("New_Program : ok");
	    if (prg_id > 0) {
		mediabox404_log_debug("New_Program > 0");
		
		// reprogrammation automatique
		if (AutoProgDelay > 0) {
		    NextAutoProgramme = NextScanProgramme + 
			(AutoProgDelay * 60);
		    Copy_Program(&mysql, &mediabox404_config,
				 &NextScanProgramme, &NextAutoProgramme);
		}
		
		// metadata
		if (strlen(MetaData) > 0) {
		    AddMetaData(&mysql, &mediabox404_config, MetaData);
		}
		
		// copy pile stream --> t_tempstack, delete pile stream
		Copy_streamstack_tempstack(&mysql, &mediabox404_config);
		
		switch (prg_type) {
		    
		case PL_STREAM :
		    mediabox404_log_debug("New Programme PL: %d", prg_id);
		    Insert_Log(&mysql, &mediabox404_config, 0, "PL", 
			       prg_id, "", "", "", "", "", "", "", "");
		    Reset_Last_Playlist(&mysql,&mediabox404_config);
		    if (StreamType == RELAY_STREAM) {
			/* this is a relay */
			flag_stop_relay = 1;
		    }
		    StreamType = PL_STREAM;
		    CurrentPlaylist = prg_id;
		    break;
		    
		case RELAY_STREAM :
		    mediabox404_log_debug("New Programme RELAY: %d",
					  prg_id);
		    if (StreamType == RELAY_STREAM) {
			/* this is a relay */
			flag_stop_relay = 1;
		    }
		    StreamType = RELAY_STREAM;
		    CurrentPlaylist = prg_id;
		    break;
		    
		case REDIF_STREAM :
		    mediabox404_log_debug("New Program REDIF: %d", prg_id);
		    Insert_Log(&mysql, &mediabox404_config, 0, "REDIF",
			       prg_id, "", "", "", "", "", "", "", "");
		    if (StreamType == RELAY_STREAM) {
			/* this is a relay */
			flag_stop_relay = 1;
		    }
		    StreamType = REDIF_STREAM;
		    CurrentPlaylist = prg_id;
		    CurrentData = data_id;
		    break;
		}
	    }
	    
	    today = localtime(&timer);
	    today->tm_sec = 0;
	    today->tm_min = 0;
	    NextScanProgramme = mktime(today);
	    while (NextScanProgramme <= timer) { 
		NextScanProgramme = NextScanProgramme + 
		    (mediabox404_config.program_timing * 60);
	    }
	    mediabox404_log_debug("NextScanProgram");
	}
	
	// Scan venement programme WWW
	if (ScanPrg > SCAN_PROG_STACK) {
	    ScanPrg = 0;
	    sprintf(query_prgstack, "select * from %s order by S_ID ASC",
		    mediabox404_config.sql.progstack);
	    query_ok = mysql_real_query(&mysql, query_prgstack,
					(unsigned int) 
					strlen(query_prgstack));
	    if (query_ok == 0) {
		res = mysql_store_result(&mysql);
		if (mysql_num_rows(res) > 0) {
		    while ((row = mysql_fetch_row(res))) {
			lengths = mysql_fetch_lengths(res);
			sprintf(CODE,"%.*s", (int) lengths[2], 
				row[2] ? row[2] : "NULL"); // Command Code LIVE
			StackPrgID = atoi(row[0]);
			
			//logfile("Pilot=%s\n",CODE);
			if (strcmp(CODE,"LIVE") == 0) {
			    UserPrgID = atoi(row[1]);
			    DataPrgID = atoi(row[4]);
			    sprintf(ARG[0],"%.*s", (int) lengths[5], row[5] ? row[5] : "NULL"); // URL
			    sprintf(ARG[1],"%.*s", (int) lengths[6], row[6] ? row[6] : "NULL"); // Format
			    LIVE_Bitrate = atoi(row[7]);// Bitrate [16000,24000,32000,48000,56000,64000,80000,96000,112000,128000,160000,196000,256000]
			    LIVE_Frequence = atoi(row[8]); // Frquence [16000,22050,24000,32000,44100,48000]
			    LIVE_NbCanal = atoi(row[9]);// Nb canaux [1,2] Mono/Stro
			    LIVE_NbReconnect = atoi(row[10]); // Nb reconnect
			    //insert LIVE dans T_StreamStack;
			    Insert_Log(&mysql,&mediabox404_config,0,"LIVE",DataPrgID,"","","","","","","","");
			    Insert_streamstack_live(&mysql,&mediabox404_config,UserPrgID,DataPrgID,ARG[0],ARG[1],LIVE_Bitrate,LIVE_Frequence,LIVE_NbCanal,LIVE_NbReconnect,0);
			    // Insert Jingle
			    Insert_Jingle(&mysql,&mediabox404_config);
			}
			
			if (strcmp(CODE,"RUN") == 0) {
			    mediabox404_log_debug("End Relay manuel");
			    CurrentPlaylist = 0;
			    flag_doublon_jingle_prg = 0;
			    StreamType = MAIN_STREAM;
			    // copy pile t_tempstack --> stream , delete pile t_tempstack
			    Copy_tempstack_streamstack(&mysql,&mediabox404_config);
			    do {Insert_Main_PL(&mysql,&mediabox404_config,&nb_control_play);} while (nb_control_play != 0);
			    // on arret le LIVE
			    Stop_Current_Stream(&mysql,&mediabox404_config);
			    EndRelay = 0;
			}
			// Purge vnement admin ID 
			Delete_ProgStackID (&mysql,&mediabox404_config,StackPrgID);
			wait = 1;
		    }
		}
		
		mysql_free_result(res);
		if (wait == 1) {
		    mediabox404_log_debug("Waiting for a Web command %s",
					  mediabox404_config.sql.mysql_options);
		    wait = 0;
		}
	    }
	}
	
	// Scan pile de morceau vide ?
	sprintf(query_streamstack, "select * from %s order by S_ID ASC",
		mediabox404_config.sql.streamstack); 
	query_ok = mysql_real_query(&mysql, query_streamstack, 
				    (unsigned int)strlen(query_streamstack));
	if (query_ok == 0) {
	    res=mysql_store_result(&mysql);
	    if (mysql_num_rows(res) == 0) {
		//logfile("StreamType=%d\n",StreamType);
		// libration des jingle et promo
		flag_doublon_jingle = 0;
		flag_doublon_promo = 0;

		switch (StreamType) {

		case MAIN_STREAM :
		    flag_doublon_jingle_prg = 0;
		    do {
			Insert_Main_PL(&mysql, &mediabox404_config,
				       &nb_control_play); 
		    } while (nb_control_play != 0);
			break;

		case RELAY_STREAM :
		    if (EndRelay == 0) {
			if (Insert_Relay(&mysql,&mediabox404_config,
					 CurrentPlaylist,PlayTime) == 1) { 
			    Insert_Log(&mysql, &mediabox404_config, 0, "RELAY",
				       CurrentPlaylist, "", "", "", "", "", "",
				       "", "");
			    Insert_Jingle(&mysql, &mediabox404_config);
			    Insert_Jingle_end(&mysql, &mediabox404_config,
					      &nb_control_play);
			    Stop_Current_Stream(&mysql, &mediabox404_config);
			    EndRelay = timer + (PlayTime/1000);
			    // pas de jingle ni de promo dans un relay
			    flag_doublon_jingle = 1;
			    flag_doublon_promo = 1;					
			} else {
			    mediabox404_log_debug("No Relay");
			    CurrentPlaylist = 0;
			    flag_doublon_jingle_prg = 0;
			    StreamType = MAIN_STREAM;
			    // copy pile t_tempstack --> stream , delete pile t_tempstack
			    Copy_tempstack_streamstack(&mysql,
						       &mediabox404_config);
			    do {
				Insert_Main_PL(&mysql, &mediabox404_config,
					       &nb_control_play); 
			    } while (nb_control_play != 0);
			}
		    } else { // fin plus de stream relay !!
			if (flag_stop_relay == 0) {
			    mediabox404_log_error("End Relay deconnect");
			    CurrentPlaylist = 0;
			    flag_doublon_jingle_prg = 0;
			    StreamType = MAIN_STREAM;
			    // copy pile t_tempstack --> stream , delete pile t_tempstack
			    Copy_tempstack_streamstack(&mysql,
						       &mediabox404_config);
			    do {
				Insert_Main_PL(&mysql, &mediabox404_config,
					       &nb_control_play);
			    } while (nb_control_play != 0);
			    // on arret le LIVE
			    Stop_Current_Stream(&mysql,&mediabox404_config);
			    EndRelay = 0;
			}
		    }
		    break;
		    
		case PL_STREAM :
		    if (Insert_PL(&mysql,&mediabox404_config,
				  CurrentPlaylist,&nb_control_play) == 0) {
			// Fin de la pl
			mediabox404_log_debug("End Program");
			CurrentPlaylist = 0;
			flag_doublon_jingle_prg = 0;
			StreamType = MAIN_STREAM;
			// copy pile t_tempstack --> stream , delete pile t_tempstack
			Copy_tempstack_streamstack(&mysql,&mediabox404_config);
			do {
			    Insert_Main_PL(&mysql,&mediabox404_config,
					   &nb_control_play); 
			} while (nb_control_play != 0);
		    } else {
			// pas de jingle ni de promo dans un programme
			flag_doublon_jingle_prg = 1;
			flag_doublon_jingle = 1;
			flag_doublon_promo = 1;
		    }
		    break;

		    case REDIF_STREAM :
			mediabox404_log_debug("REDIF_STREAM : DataID:%d",
					      CurrentData);
			// copy pile t_tempstack --> stream , delete pile t_tempstack
			Copy_tempstack_streamstack(&mysql,&mediabox404_config);
			Insert_streamstack_data_begin(&mysql,
						      &mediabox404_config,
						      CurrentPlaylist,
						      CurrentData,1,"REDIF"); 
			// Playlist == 1 Data
			CurrentPlaylist = 0;
			StreamType = MAIN_STREAM;
			break;
		}
		
	    }
	    mysql_free_result(res);
	}
	
	// fin d'un relay auto
	if (StreamType == RELAY_STREAM) {
	    if ((timer >= EndRelay) && (EndRelay > 0)) {
		// c'est la fin du relay
		if (flag_stop_relay == 0) {
		    mediabox404_log_debug("End Relay auto");
		    CurrentPlaylist = 0;
		    flag_doublon_jingle_prg = 0;
		    StreamType = MAIN_STREAM;
		    // copy pile t_tempstack --> stream , delete pile t_tempstack
		    Copy_tempstack_streamstack(&mysql,&mediabox404_config);
		    do {
			Insert_Main_PL(&mysql,&mediabox404_config,
				       &nb_control_play);
		    } while (nb_control_play != 0);
		    // on arret le LIVE
		    Stop_Current_Stream(&mysql,&mediabox404_config);
		    EndRelay = 0;
		}
	    }
	}
	// fin d'un relay par un autre programme
	if (flag_stop_relay == 1) {
	    flag_stop_relay = 0;
	    // on arret le Relay
	    if (StreamType != RELAY_STREAM) {
		Stop_Current_Stream(&mysql,&mediabox404_config);
	    }
	    EndRelay = 0;
	}
	
	ScanPrg++;
	sleep(1);
    }
    
    mysql_close(&mysql);
    
    mediabox404_log("Exit Programmation Mediabox404_audio");
    
    return EXIT_SUCCESS;
}
