/* $Id: stream404.c,v 1.1.1.1 2005/05/28 17:24:36 bedlam Exp $ */
/* stream404.c
 * - Main Program *
 * Copyright (c) 2000 Alexander Havng
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "definitions.h"
#include <sys/resource.h>

stream404_config_t stream404_config;

/* Global function definitions */

/* Stream404 starts here. But ends in stream404_setup_shutdown(),
 * which calls exit(0) and that's the last you see of it. */
int 
main (int argc, char **argv)
{
  /* Verify if we have to save core when segfaulting */
#ifdef ALLOW_COREDUMP
  {
    struct rlimit rlimit;
    rlimit.rlim_cur = RLIM_INFINITY;
    rlimit.rlim_max = RLIM_INFINITY;
    
    if (setrlimit(RLIMIT_CORE, &rlimit) != 0) {
      fprintf(stderr, "setrlimit() cannot set coredump size\n");
      exit(0);
    }
  }
#endif
  
  /* Make command line arguments available through 
   * stream404_util_get_argc() and argv */
  stream404_util_set_args (argc, argv);
  
  /* Setup all options, and initialize all submodules */
  stream404_setup_initialize ();
  
  /* Connect to server and keep streaming all the good stuff */
  stream404_stream_loop (&stream404_config);
  
  /* Not reached */
  return 0;
}
