/* $Id: util.h,v 1.1.1.1 2005/05/28 17:24:34 bedlam Exp $ */
/* util.h
 * - utility function declarations for ices
 * Copyright (c) 2000 Alexander Havng
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

/* Public function declarations */
char **stream404_util_get_argv (void);
int stream404_util_get_argc (void);
char *stream404_util_strdup (const char *string);
void stream404_util_set_args (int argc, char **argv);
int stream404_util_open_for_reading (const char *file);
int stream404_util_valid_fd (int fd);
FILE *stream404_util_fopen_for_writing (const char *file);
FILE *stream404_util_fopen_for_reading (const char *file);
void stream404_util_fclose (FILE *fp);
char *stream404_util_read_line (FILE *fp);
char *stream404_util_get_random_filename (char *namespace, char *type);
int stream404_util_remove (const char *filename);
int stream404_util_get_random (void);
int stream404_util_is_regular_file (int fd);
int stream404_util_directory_create (const char *filename);
int stream404_util_directory_exists (const char *filename);
const char *stream404_util_nullcheck (const char *string);
double stream404_util_percent (int this, int of_that);
char *stream404_util_file_time (unsigned int bitrate, unsigned int filesize,
			   char *namespace);
const char *stream404_util_strerror (int error, char *namespace, int maxsize);
void stream404_util_free (void *ptr);
int stream404_util_verify_file (const char *filename);
void initproctitle (int argc, char **argv);
void setproctitle (const char *prog, const char *txt);
